<template>
  <div id="channels">

    <div id="talkingArea">
      <div id="channelsList" v-if="channelsList.length > 0">
        <button id="newChanButton" @click="showModal()"> 
          <i class="fas fa-plus"></i>
           Create a new channel <font-awesome-icon icon="coffee" />
        </button>
        <chan
          :class="{highlight: (selected === channel._id)}"
          v-for="channel in channelsList"
          v-bind:data="channel"
          v-bind:key="channel._id"
          :chan="channel"
          v-on:deleteChan="updateChannelList($event)"
          v-on:chanToShow="showChan($event)"
        ></chan>
      </div>
      <div id="loadingChannelsList" v-else>icon de chargement</div>

      <div id="chosenConversation">
        <h3 id="channeltitle">{{channelTitle}}</h3>

        <div id="listOfMessages" v-chat-scroll="{always: false, scrollonremoved:true}">
          <div
            class="oneMessage"
            v-for="mess in messagesList"
            v-bind:data="mess"
            v-bind:key="mess._id"
          >
            <div class="circle"> </div>
            <div>
                <div v-for="memb in members" v-bind:data="memb" v-bind:key="memb._id">
                  <div v-if="memb._id == mess.member_id">
                    <b>{{memb.fullname}}</b>
                  </div>
                </div>
                {{mess.message}}
            </div>
          </div>
        </div>
        <input
          :class="{hideInput: (selected === '')}"
          id="newMessage"
          v-on:keyup.enter="submitNewMessage"
          v-model="newMessage"
          placeholder="New message..."
        >
      </div>
    </div>

    <modal
      name="create-channel"
      transition="pop-out"
      :width="modalWidth"
      height="auto"
      @before-close="beforeClose"
    >
      <div class="box">
        <div class="partition">
          <div class="partition-title">CREATE A NEW CHANNEL</div>
          <div class="partition-msg">{{errorMessage}}</div>
          <div style="margin-top: 15px"></div>
          <div class="partition-form">
            <form autocomplete="false">
              <input
                id="n-channelname"
                type="text"
                v-model="newChannelName"
                placeholder="Channel's name"
              >
              <input
                id="n-channeldescr"
                type="text"
                v-model="newChannelDescr"
                placeholder="Description "
              >
            </form>

            <div style="margin-top: 32px"></div>

            <div class="button-set">
              <button id="cancel-btn" @click="hideModal()">Cancel</button>
              <button id="create-btn" @click="createChannel()">Create</button>
            </div>
          </div>
        </div>
      </div>
    </modal>
  </div>
</template>

<script>
import Chan from "@/components/Chan.vue";

const MODAL_WIDTH = 656;

export default {
  name: "Channel",
  components: {
    Chan
  },
  data() {
    return {
      //create new channel through modal
      newChannelName: "",
      newChannelDescr: "",
      modalWidth: MODAL_WIDTH,
      errorMessage: "",

      //list of channels
      channelsList: [],
      selected: "",

      //chosen conversation
      channelTitle: "",
      mess:
        "Lorem, ipsum dolor sit amet consectetur adipisicing elit. " +
        "Mollitia natus vero vitae alias reprehenderit! Harum atquealias" +
        " fugiat, voluptas obcaecati aliquid repudiandae tenetur reprehenderit" +
        " ducimus illum? Ipsum facilis laudantium fugiat.",
      messagesList: [],
      members: [],

      //new message
      newMessage: "",
      connectedMember: "",
      nameOfWritter: ""
    };
  },
  created() {
    this.modalWidth =
      window.innerWidth < MODAL_WIDTH ? MODAL_WIDTH / 2 : MODAL_WIDTH;
  },
  mounted() {
    window.axios
      .get("channels")
      .then(response => {
        this.channelsList = response.data;
      })
      .catch(error => {
        alert(error.message);
      });

    this.checkConnectedMember();
  },
  computed: {
    // //to always get the newest channel at the top
    // reversedChannels : function(){
    //     return this.channelsList.reverse()
    // }
  },
  methods: {
    createChannel() {
      // let defautName = "channel " + Math.floor(Math.random() * Math.floor(50000));

      if (this.newChannelName == "") {
        this.errorMessage = "Choose a channel name";
      }
      this.channelsList.forEach(chan => {
        if (chan.label == this.newChannelName) {
          this.errorMessage = "This channel name already exist";
        }
      });

      window.axios
        .post("channels", {
          label: this.newChannelName,
          topic: this.newChannelDescr
        })
        .then(response => {
          this.channelsList.push(response.data);
          this.hideModal();
        })
        .catch(error => {
          alert(error.message);
        });
    },

    updateChannelList(chanToDelete_id) {
      this.channelTitle = "default";
      for (var i = 0; i < this.channelsList.length; i++) {
        if (this.channelsList[i]._id === chanToDelete_id) {
          this.channelsList.splice(i, 1);
        }
      }
    },

    //modal method
    showModal() {
      this.$modal.show("create-channel", { foo: "im a oustiti" });
    },

    //modal method
    hideModal() {
      this.$modal.hide("create-channel");
      this.errorMessage = "";
    },

    //modal method
    beforeOpenModal(event) {
    },

    //modal method
    beforeClose(event) {
      this.newChannelName = "";
      this.newChannelDescr = "";
      this.errorMessage = "";
    },

    showChan(chanToShow_id) {
      this.selected = chanToShow_id;
      window.axios
        .get("channels/" + chanToShow_id)
        .then(response => {
          this.channelTitle = response.data.label;

          window.axios
            .get("channels/" + chanToShow_id + "/posts")
            .then(response => {
              this.messagesList = [];

              response.data.forEach(m => {
                this.messagesList.push(m);
                this.members = this.$store.state.allMembers[0];
              });

            })
            .catch(error => {
              alert(error.response.data.error);
            });
        })
        .catch(error => {
          alert(error.response.data.error);
        });
    },

    submitNewMessage() {
      window.axios
        .post("channels/" + this.selected + "/posts", {
          message: this.newMessage
        })
        .then(response => {
          // this.messagesList.push(newMessage._value);
          this.newMessage = "";
          this.showChan(this.selected);
        })
        .catch(error => {
          alert(error.response.data.error);
        });
    },

    checkConnectedMember() {
      this.$store.state.allMembers[0].forEach(member => {
        if (member._id == this.$store.state.member.id) {
          this.connectedMember = member;
        }
      });
      console.log(this.connectedMember);
    }
  }
};
</script>

<style lang="scss">


.box {
  background: rgb(16, 13, 17);
  overflow: hidden;
  width: 656px;
  height: auto;
  border-radius: 2px;
  box-sizing: border-box;
  box-shadow: 0 0 40px black;
  color: #8b8c8d;
  font-size: 0;

  .partition {
    width: 100%;
    height: 100%;
    .partition-title {
      box-sizing: border-box;
      padding: 30px;
      width: 100%;
      text-align: center;
      letter-spacing: 1px;
      font-size: 20px;
      font-weight: 300;
    }
    .partition-msg {
      box-sizing: border-box;
      padding: 5px;
      width: 100%;
      text-align: center;
      font-size: 15px;
      font-weight: 300;
      background-color: #29272E;
      color: #336699;
    }
    .partition-form {
      padding: 0 20px;
      font-size: 20px;
      box-sizing: border-box;
    }
  }
  input[type="password"],
  input[type="text"] {
    display: block;
    box-sizing: border-box;
    margin-bottom: 4px;
    width: 100%;
    font-size: 15px;
    line-height: 2;
    border: 0;
    border-bottom: 1px solid #29272E;
    padding: 4px 8px;
    font-family: inherit;
    transition: 0.5s all;
    outline: none;
    background-color: #2B212C;
  }

  button {
    background: #29272E;
    border-radius: 4px;
    box-sizing: border-box;
    padding: 10px;
    letter-spacing: 1px;
    font-family: "Open Sans", sans-serif;
    font-weight: 400;
    min-width: 140px;
    margin: 8px 0 8px 0;
    color: #8b8c8d;
    cursor: pointer;
    border: 1px solid #29272E;
    text-transform: uppercase;
    transition: 0.1s all;
    font-size: 10px;
    outline: none;
    &:hover {
      border-color: mix(#dddedf, black, 90%);
      color: mix(#dddedf, black, 90%);
      background-color: #29272E;
    }
  }
  .button-set {
    margin-bottom: 8px;
    display: flex;
    justify-content: space-between;
  }
}
.pop-out-enter-active,
.pop-out-leave-active {
  transition: all 0.5s;
}
.pop-out-enter,
.pop-out-leave-active {
  opacity: 0;
  transform: translateY(24px);
}

#channels{
  border : none;
  margin : 0;
  padding: 0;
  height: 100%;

}

#talkingArea {
  display: flex;
  height: 100%;
  margin: 0;
  background-color: #2A2634;
  padding : 0;

  #loadingChannelsList {
    width: 25em;
  }
  $talkingAndChosenColor : #302637;

  #channelsList {
    display: flex;
    flex-direction: column;
    justify-items: left;
    width: 25em;
    border-top: 1px solid #2A2634;
    border-left: 1px solid #2A2634;
    border-bottom: 1px solid #2A2634;
    padding : 0;

    background-color: #24242A;
    overflow: hidden;
    user-select: none;
    .highlight {
      background-color: $talkingAndChosenColor;
      &:hover {
        background-color: $talkingAndChosenColor;
      }
    }

    #newChanButton{
      color : #b7bfc7;
      background-color: #2A2634;
      border : none;
      padding : 10px;
      margin : 0;
      &:hover{
        cursor: pointer;
      }
    }
  }

  $lightpurple : rgb(165, 160, 187);
  #chosenConversation {
    background-color: $talkingAndChosenColor;
    border-top: 1px solid #2A2634;
    border-right: 1px solid #2A2634;
    border-bottom: 1px solid #2A2634;
    margin : 0;
    padding: 0 1em 0 5em;
    flex: 1;
    color: $lightpurple ;

    #channeltitle {
      margin : 0 10% 0 0 ;
      padding: 15px;
      text-align: center;
      color: $lightpurple ;
    }
    #listOfMessages {
      height: 80%;
      overflow-y: scroll;
      .oneMessage {
        margin : 20px 0;
        padding : 10px;
        display: flex;
        align-items: center;
        background-color: #261F28;
        border-radius : 20px;
        width : 90%;
        .circle{
          margin-right :20px;
          width : 50px;
          height : 50px;
          background-color:  $talkingAndChosenColor ;
          border-radius : 50%
        }
      }

    }
    #newMessage {
      margin : 20px 0 10px 0;
      width: 87%;
      height: 2em;
      padding: 5px 10px;
      background-color: #261F28;
      border-radius: 5px;
      color: $lightpurple ;
      

    }
    .hideInput {
      display: none;
    }
  }
}
</style>
